
struct codeS;
class Cfunction;
class Cfile;

typedef struct matchesS {
	struct matchesS *m_nextP;
	struct codeS	*m_codeP;
} matchesT;

// Make this the largest negative number
#define JUMP_UNDEFINED 0x80000000

typedef struct codeS {
	struct codeS	*m_hashP;		// Linked list of codes hashing to the same hash chain
	Cfunction		*m_functionP;	// Function this instruction belongs to
	Cfile			*m_fileP;		// Source file instruction contained in
	int				m_source_lineno;// Corresponding lineno in source file
	char			*m_codeP;		// Contents of this assember instruction
	int				m_jump;			// Distance jumping forwards back
	struct codeS	*m_matchP;		// The matching instruction else 0
	matchesT		*m_matchesP;	// List of all matches to date
} codeT;

