void outofmemory(void);

#ifndef NDEBUG
//#define TEST_MALLOC
#endif

#ifdef TEST_MALLOC

void *xmalloc2(int size, char *fileP, int lineno);
void *xrealloc2(void *P, int size, char *fileP, int lineno);
void xfree2(void *P);

#define Xmalloc(X) xmalloc2(X, __FILE__, __LINE__)
#define Xrealloc(X,Y) xrealloc2(X, Y, __FILE__, __LINE__)
#define Xfree(X) xfree2(X)

#else

void *xmalloc1(int size);
void *xrealloc1(void *P, int size);
void xfree1(void *P);

#define Xmalloc(X) xmalloc1(X)
#define Xrealloc(X,Y) xrealloc1(X,Y)
#define Xfree(X) xfree1(X)
#endif

